diff --git a/drivers/crypto/ti/Kconfig b/drivers/crypto/ti/Kconfig
index 39d9d8cb6b78..ab4da73dffc4 100644
--- a/drivers/crypto/ti/Kconfig
+++ b/drivers/crypto/ti/Kconfig
@@ -6,6 +6,7 @@ config CRYPTO_DEV_TI_DTHE_V2
 	select CRYPTO_SKCIPHER
 	select CRYPTO_SHA256
 	select CRYPTO_SHA512
+	select CRYPTO_MD5
 	help
 	  This enables support for the TI DTHE V2 hw crypto accelerator
 	  which can be found on TI K3 SOCs. Selecting this enables use
diff --git a/drivers/crypto/ti/dthev2.c b/drivers/crypto/ti/dthev2.c
index d5ed0f4621f5..ff2d5ef47c2a 100644
--- a/drivers/crypto/ti/dthev2.c
+++ b/drivers/crypto/ti/dthev2.c
@@ -25,6 +25,7 @@
 #include <crypto/internal/aead.h>
 #include <crypto/internal/hash.h>
 #include <crypto/internal/skcipher.h>
+#include <crypto/md5.h>
 #include <crypto/sha2.h>
 
 #include <linux/delay.h>
@@ -363,6 +364,25 @@ static int dthe_sha224_cra_init(struct crypto_tfm *tfm)
 	return 0;
 }
 
+static int dthe_md5_cra_init(struct crypto_tfm *tfm)
+{
+	struct dthe_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
+	struct dthe_data *dev_data = dthe_get_dev(ctx);
+
+	if (!dev_data)
+		return -ENODEV;
+
+	ctx->ctx_info.hash_ctx = kzalloc(sizeof(*ctx->ctx_info.hash_ctx), GFP_KERNEL);
+	if (!ctx->ctx_info.hash_ctx)
+		return -ENOMEM;
+
+	ctx->ctx_info.hash_ctx->mode = DTHE_HASH_MD5;
+	ctx->ctx_info.hash_ctx->block_size = MD5_BLOCK_WORDS * 4;
+	ctx->ctx_info.hash_ctx->digest_size = MD5_DIGEST_SIZE;
+	ctx->ctx_info.hash_ctx->phash_size = MD5_DIGEST_SIZE;
+	return 0;
+}
+
 static void dthe_hash_cra_exit(struct crypto_tfm *tfm)
 {
 	struct dthe_tfm_ctx *ctx = crypto_tfm_ctx(tfm);
@@ -602,6 +622,8 @@ static int dthe_hash_update(struct ahash_request *req)
 				memcpy(sctx->phash, sha256_zero_message_hash, sctx->digest_size);
 			else if (sctx->mode == DTHE_HASH_SHA224)
 				memcpy(sctx->phash, sha224_zero_message_hash, sctx->digest_size);
+			else if (sctx->mode == DTHE_HASH_MD5)
+				memcpy(sctx->phash, md5_zero_message_hash, sctx->digest_size);
 		}
 
 		return 0;
@@ -736,6 +758,8 @@ static int dthe_hash_final(struct ahash_request *req)
 			memcpy(req->result, sha256_zero_message_hash, sctx->digest_size);
 		else if (sctx->mode == DTHE_HASH_SHA224)
 			memcpy(req->result, sha224_zero_message_hash, sctx->digest_size);
+		else if (sctx->mode == DTHE_HASH_MD5)
+			memcpy(req->result, md5_zero_message_hash, sctx->digest_size);
 	}
 
 	memcpy(req->result, sctx->phash, sctx->digest_size);
@@ -774,6 +798,8 @@ static int dthe_hash_finup(struct ahash_request *req)
 				memcpy(req->result, sha256_zero_message_hash, sctx->digest_size);
 			else if (sctx->mode == DTHE_HASH_SHA224)
 				memcpy(req->result, sha224_zero_message_hash, sctx->digest_size);
+			else if (sctx->mode == DTHE_HASH_MD5)
+				memcpy(req->result, md5_zero_message_hash, sctx->digest_size);
 		}
 		return 0;
 	}
@@ -870,6 +896,8 @@ static int dthe_hash_digest(struct ahash_request *req)
 			memcpy(req->result, sha256_zero_message_hash, sctx->digest_size);
 		else if (sctx->mode == DTHE_HASH_SHA224)
 			memcpy(req->result, sha224_zero_message_hash, sctx->digest_size);
+		else if (sctx->mode == DTHE_HASH_MD5)
+			memcpy(req->result, md5_zero_message_hash, sctx->digest_size);
 		return 0;
 	}
 
@@ -1366,6 +1394,34 @@ static struct ahash_alg hash_algs[] = {
 			}
 		}
 	},
+	{
+		.init	= dthe_hash_init,
+		.update	= dthe_hash_update,
+		.final	= dthe_hash_final,
+		.finup	= dthe_hash_finup,
+		.digest	= dthe_hash_digest,
+		.export = dthe_hash_export,
+		.import = dthe_hash_import,
+		.halg	= {
+			.digestsize = MD5_DIGEST_SIZE,
+			.statesize = sizeof(struct dthe_hash_ctx),
+			.base = {
+				.cra_name	 = "md5",
+				.cra_driver_name = "md5-dthe_v2",
+				.cra_priority	 = 400,
+				.cra_flags	 = CRYPTO_ALG_TYPE_AHASH |
+						   CRYPTO_ALG_ASYNC |
+						   CRYPTO_ALG_OPTIONAL_KEY |
+						   CRYPTO_ALG_KERN_DRIVER_ONLY |
+						   CRYPTO_ALG_ALLOCATES_MEMORY,
+				.cra_blocksize	 = MD5_BLOCK_WORDS * 4,
+				.cra_ctxsize	 = sizeof(struct dthe_tfm_ctx),
+				.cra_module	 = THIS_MODULE,
+				.cra_init	 = dthe_md5_cra_init,
+				.cra_exit	 = dthe_hash_cra_exit,
+			}
+		}
+	},
 };
 
 static struct skcipher_alg cipher_algs[] = {